<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/hext_py.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>hext_py.c</h1><a href="hext__py_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment">    Copyright (C) 2009 Amit Itagi</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00008"></a>00008 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00011"></a>00011 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00012"></a>00012 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00013"></a>00013 <span class="comment">    (at your option) any later version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00016"></a>00016 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00017"></a>00017 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00018"></a>00018 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00021"></a>00021 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00022"></a>00022 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00023"></a>00023 <span class="comment">*/</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: hext_py.c 2983 2010-02-22 22:56:23Z scholz $\n\n&quot;</span>;
<a name="l00026"></a>00026 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">static</span> <span class="keywordtype">int</span>       doinit=1;
<a name="l00032"></a>00032 <span class="keyword">static</span> <span class="keywordtype">int</span>       fieldon=0;
<a name="l00033"></a>00033 <span class="keyword">static</span> Vec       VHthis;
<a name="l00034"></a>00034 <span class="keyword">static</span> PetscReal hextamp=0.0;
<a name="l00035"></a>00035 
<a name="l00036"></a><a class="code" href="hext__py_8c.html#a53aac86dc06657ac5dc89f8f21bd4a70">00036</a> <span class="keywordtype">int</span> <a class="code" href="hext__py_8c.html#a53aac86dc06657ac5dc89f8f21bd4a70">Hext_py_Init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   PetscTruth flg;
<a name="l00041"></a>00041   <span class="keywordtype">char</span> str[256];
<a name="l00042"></a>00042   ierr = PetscOptionsGetString(PETSC_NULL,<span class="stringliteral">&quot;-hext_py&quot;</span>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00043"></a>00043   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00044"></a>00044     fieldon=0;
<a name="l00045"></a>00045     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00046"></a>00046       <span class="stringliteral">&quot;Option -hext_py not found, using default value: %i (field off)\n&quot;</span>,
<a name="l00047"></a>00047       fieldon
<a name="l00048"></a>00048     );
<a name="l00049"></a>00049   }
<a name="l00050"></a>00050   <span class="keywordflow">else</span> {
<a name="l00051"></a>00051     fieldon=1;
<a name="l00052"></a>00052   }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00055"></a>00055     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hext_py off\n&quot;</span>);
<a name="l00056"></a>00056     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00057"></a>00057   }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="preprocessor">#ifdef PYTHON</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hext_py on, using Python script: %s\n&quot;</span>,str);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;VHthis);CHKERRQ(ierr);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">/* Python stuff */</span>
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   PyObject *pFunc;
<a name="l00067"></a>00067   pFunc=PyObject_GetAttrString(gdata-&gt;pModule,str);  <span class="comment">/* new reference */</span>
<a name="l00068"></a>00068   <span class="keywordflow">if</span>(!pFunc) {
<a name="l00069"></a>00069     SETERRQ1(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;Cannot find Python function %s!\n&quot;</span>,str);
<a name="l00070"></a>00070   }
<a name="l00071"></a>00071   <span class="keywordflow">if</span> (!PyCallable_Check(pFunc)) {
<a name="l00072"></a>00072     SETERRQ1(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;Python object %s is not callable (not a function)!\n&quot;</span>,str);
<a name="l00073"></a>00073   }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="comment">/* Arguments for the module */</span>
<a name="l00076"></a>00076   PyObject *pTuple;
<a name="l00077"></a>00077   pTuple = PyTuple_New(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>); <span class="comment">/* new reference */</span>
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   PyObject *pVal=PETSC_NULL;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">/* make the vector of the external field accessible */</span>
<a name="l00082"></a>00082   PetscReal *ta_Hext;
<a name="l00083"></a>00083   ierr = VecGetArray(VHthis,&amp;ta_Hext);CHKERRQ(ierr);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">/* loop over all (local) nodes */</span>
<a name="l00086"></a>00086   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; j++) {
<a name="l00087"></a>00087     ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(j,gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,10);
<a name="l00088"></a>00088     PetscReal x,y,z;
<a name="l00089"></a>00089     x=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[j]+0];
<a name="l00090"></a>00090     y=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[j]+1];
<a name="l00091"></a>00091     z=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[j]+2];
<a name="l00092"></a>00092 
<a name="l00093"></a>00093     PyTuple_SetItem(pTuple,0,PyFloat_FromDouble(x)); <span class="comment">/* The tuple steals the reference */</span>
<a name="l00094"></a>00094     PyTuple_SetItem(pTuple,1,PyFloat_FromDouble(y));
<a name="l00095"></a>00095     PyTuple_SetItem(pTuple,2,PyFloat_FromDouble(z));
<a name="l00096"></a>00096 
<a name="l00097"></a>00097     <span class="comment">/* Call the Python function */</span>
<a name="l00098"></a>00098     pVal = PyObject_CallObject(pFunc,pTuple);  <span class="comment">/* new reference */</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     <span class="comment">/* set external field */</span>
<a name="l00101"></a>00101     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>; i++) {
<a name="l00102"></a>00102       ta_Hext[ND*j+i]=PyFloat_AsDouble(PyTuple_GetItem(pVal,i));
<a name="l00103"></a>00103     }
<a name="l00104"></a>00104   }
<a name="l00105"></a>00105   ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(1,1,10);
<a name="l00106"></a>00106   ierr = VecRestoreArray(VHthis,&amp;ta_Hext);CHKERRQ(ierr);
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">/* decrement references */</span>
<a name="l00109"></a>00109   Py_DECREF(pFunc);
<a name="l00110"></a>00110   Py_DECREF(pTuple);
<a name="l00111"></a>00111   Py_DECREF(pVal);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="keywordtype">int</span> k;
<a name="l00114"></a>00114   ierr = VecMax(VHthis,&amp;k,&amp;hextamp);CHKERRQ(ierr);
<a name="l00115"></a>00115 <span class="preprocessor">#else</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>  SETERRQ(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;magpar not linked with Python interpreter. Cannot execute Python scripts!\n&quot;</span>);
<a name="l00117"></a>00117 <span class="preprocessor">#endif</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>
<a name="l00119"></a>00119   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00120"></a>00120 }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a><a class="code" href="hext__py_8c.html#a9570f5d09accfa97e676f862b1acb592">00123</a> <span class="keywordtype">int</span> <a class="code" href="hext__py_8c.html#a9570f5d09accfa97e676f862b1acb592">hext_f</a>(<a class="code" href="structGridData.html">GridData</a> *gdata, PetscReal time_ns)
<a name="l00124"></a>00124 {
<a name="l00125"></a>00125 <span class="preprocessor">#ifdef PYTHON</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>  <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="keywordtype">char</span> str[256]=<span class="stringliteral">&quot;hext_f&quot;</span>;
<a name="l00129"></a>00129   PyObject *pFunc;
<a name="l00130"></a>00130   pFunc=PyObject_GetAttrString(gdata-&gt;pModule,str);  <span class="comment">/* new reference */</span>
<a name="l00131"></a>00131   <span class="keywordflow">if</span>(!pFunc) {
<a name="l00132"></a>00132     SETERRQ1(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;Cannot find Python function %s!\n&quot;</span>,str);
<a name="l00133"></a>00133   }
<a name="l00134"></a>00134   <span class="keywordflow">if</span> (!PyCallable_Check(pFunc)) {
<a name="l00135"></a>00135     SETERRQ1(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;Python object %s is not callable (not a function)!\n&quot;</span>,str);
<a name="l00136"></a>00136   }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">/* Arguments for the module */</span>
<a name="l00139"></a>00139   PyObject *pTuple;
<a name="l00140"></a>00140   pTuple = PyTuple_New(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>); <span class="comment">/* new reference */</span>
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   PyObject *pVal=PETSC_NULL;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   PyTuple_SetItem(pTuple,0,PyFloat_FromDouble(time_ns)); <span class="comment">/* The tuple steals the reference */</span>
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="comment">/* Call the Python function */</span>
<a name="l00147"></a>00147   pVal = PyObject_CallObject(pFunc,pTuple);  <span class="comment">/* new reference */</span>
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   PetscReal f;
<a name="l00150"></a>00150   f=PyFloat_AsDouble(PyTuple_GetItem(pVal,0));
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">/* decrement references */</span>
<a name="l00153"></a>00153   Py_DECREF(pFunc);
<a name="l00154"></a>00154   Py_DECREF(pTuple);
<a name="l00155"></a>00155   Py_DECREF(pVal);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(f);
<a name="l00158"></a>00158 <span class="preprocessor">#else</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span>  SETERRQ(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;magpar not linked with Python interpreter. Cannot execute Python scripts!\n&quot;</span>);
<a name="l00160"></a>00160 <span class="preprocessor">#endif</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>}
<a name="l00162"></a>00162 
<a name="l00163"></a><a class="code" href="hext__py_8c.html#a66aec7a3ca42c0059d2b330ca937a555">00163</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a66aec7a3ca42c0059d2b330ca937a555">Hext_py</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VHextsum,PetscReal *hext)
<a name="l00164"></a>00164 {
<a name="l00165"></a>00165   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   <span class="comment">/* to be implemented by the user */</span>
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="keywordflow">if</span> (doinit) {
<a name="l00170"></a>00170     ierr = <a class="code" href="hext__py_8c.html#a53aac86dc06657ac5dc89f8f21bd4a70">Hext_py_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00171"></a>00171     doinit=0;
<a name="l00172"></a>00172   }
<a name="l00173"></a>00173   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00174"></a>00174     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00175"></a>00175   }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   ierr = VecAXPY(VHextsum,1.0,VHthis);CHKERRQ(ierr);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">/* get time in nanoseconds */</span>
<a name="l00180"></a>00180   PetscReal nstime;
<a name="l00181"></a>00181   nstime=gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9;
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">/* get scaling factor */</span>
<a name="l00184"></a>00184   PetscReal hext2;
<a name="l00185"></a>00185 <span class="comment">/* DEBUG */</span>
<a name="l00186"></a>00186 <span class="preprocessor">#if 0</span>
<a name="l00187"></a>00187 <span class="preprocessor"></span>  hext2=<a class="code" href="hext__py_8c.html#a9570f5d09accfa97e676f862b1acb592">hext_f</a>(gdata,nstime);
<a name="l00188"></a>00188 <span class="preprocessor">#else</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>  hext2=0;
<a name="l00190"></a>00190 <span class="preprocessor">#endif</span>
<a name="l00191"></a>00191 <span class="preprocessor"></span>
<a name="l00192"></a>00192   ierr = VecAXPY(VHextsum,hext2,VHthis);CHKERRQ(ierr);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   *hext=hextamp;
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00197"></a>00197 }
<a name="l00198"></a>00198 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

